#include <stdio.h>
#include <stdlib.h>
#include <iostream>

using namespace std;

int br_del(int x){
    int br=0;
    for(int i = 1; i <= x/2; i++){
        if(x%i == 0)
            br++;
    }
    return br+1;
}

void delioci(int* a, int x){
    int br = 0;
    for(int i = 1; i <= x/2; i ++){
        if(x%i ==0){
            a[br] = i;
            br++;
        }
    }
    a[br_del(x)-1] = x;
}

int xor_delilaca(int x){
    int n = br_del(x);
    int a[n];
    delioci(a, x);
    int s = a[0];
    for(int i = 1; i < n; i ++){
        s = (s^a[i]);
    }
    return s;
}

int main(){
    long long int n;
    int k;
    cin >> n >> k;
    int a[k];
    for(int i = 0; i< k; i ++){
        cin >> a[i];
    }
    for(int i = 0; i< k; i ++){
        cout << xor_delilaca(a[i]) << " ";
    }
    return 0;
}